unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Controls.Presentation, FMX.StdCtrls, FMXTee.Engine, FMXTee.Series,
  FMXTee.Procs, FMXTee.Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TBarSeries;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Single);
    procedure FormCreate(Sender: TObject);
    procedure Chart1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
  private
    { Private declarations }
    MoveEnabled: Boolean;
    FOldX: Single;
    FOldY: Single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.Button1Click(Sender: TObject);
begin
  MoveEnabled:=not MoveEnabled;
end;

procedure TForm1.Chart1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FOldX:=X;
  FOldY:=Y;
end;

procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Single);

  Procedure Set3D;
  begin
    Chart1.View3D:=True;
  end;

  procedure DoMove;
  var tmpZ : Double;
    begin

      if not Chart1.Canvas.SupportsFullRotation then // SupportsZoom2D
         Set3D;

      With Chart1.View3DOptions do
      begin
        tmpZ:=1;

        HorizOffsetFloat:=HorizOffsetFloat+((X-FOldX)*tmpZ);
        VertOffsetFloat:=VertOffsetFloat+((Y-FOldY)*tmpZ);
      end;

      Chart1.Invalidate;

      FOldX:=X;
      FOldY:=Y;
  end;

begin
  if MoveEnabled then
    DoMove;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MoveEnabled:=False;
end;

end.
